<template>
  <a-row type="flex" justify="center">
    <a-col :span="24">
      <a-page-header title="Einkaufswagen"></a-page-header>
      <a-list item-layout="horizontal" :data-source="items" :loading="loading">
        <a-list-item slot="renderItem" slot-scope="item, index">
          <a-list-item-meta
            :description="item.product.product.description"
          >
            <a slot="title" :href="'/products/' + item.product.product.id">{{ item.product.fullName }}</a>
            <a-avatar
              slot="avatar"
              size="large"
              :src="getImageUrl(item)"
            />
          </a-list-item-meta>
          <a-row type="flex" justify="end" :gutter="20" :style="{ flex: '1 0 auto' }">
            <a-col>
              <a-statistic class="price--smaller" :precision="2" :value="item.product.product.price" suffix="€"></a-statistic>
            </a-col>
            <a-col>
              <a-input-number size="large" :min="1" :max="item.product.inStock" :default-value="1" @change="(val) => onChange(item, val)" v-model="{ ...item }.amount"/>
            </a-col>
          </a-row>
        </a-list-item>
        <div slot="footer" class="list-footer"><a-statistic title="Gesamt" :precision="2" :value="totalPrice" suffix="€"></a-statistic></div>
      </a-list>
    </a-col>
  </a-row>
</template>

<script lang="ts">
import Vue from 'vue'

export default Vue.extend({
  data() {
    return {
      loading: true as boolean
    }
  },
  computed: {
    items(): Array<any> {
      return this.$store.state.cart.currentItems
    },
    totalPrice(): number {
      return this.items.reduce((acc, current) => {
        return acc + current.amount * current.product.product.price
      }, 0)
    }
  },
  methods: {
    getImageUrl(item: any) {
      if (!item.product.product.images || item.product.product.images.length === 0) {
        return ''
      }
      if (item.product.product.images[0].url.startsWith('http')) {
        return item.product.product.images[0].url
      }
      return `${process.env.strapiBaseUri}${item.product.product.images[0].url}`
    },
    onChange(item: any, val: number) {
      this.$store.commit('cart/updateCount', {
        item: item.product,
        count: val
      })
    }
  },
  mounted() {
    setTimeout(() => {
      this.loading = false
    }, 1500)
  },
  beforeUpdate () {
    if (this.items.length > 0) {
      this.loading = false
    }
  }
})
</script>

<style lang="scss">
.price--smaller {
  .ant-statistic-content {
    .ant-statistic-content-value-int {
      font-size: 20px
    }
    .ant-statistic-content-value-decimal, .ant-statistic-content-suffix {
      font-size: 14px;
    }
  }
}
</style>
<style lang="scss" scoped>
.list-footer {
  text-align: right;
}
</style>
